/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __json_SurfaceAccessibleGeo_h__
#define __json_SurfaceAccessibleGeo_h__

namespace fe
{

/**************************************************************************//**
    @brief JSON Geo Surface Binding

	@ingroup json
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleGeo:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleGeo(void)					{}
virtual							~SurfaceAccessibleGeo(void)					{}

								//* As Protectable
virtual	Protectable*			clone(Protectable* pInstance=NULL);

								//* as SurfaceAccessibleI

virtual	void					bind(Instance a_instance)
								{
									m_spJsonRoot=
											a_instance.cast< sp<Component> >();
								}
virtual	BWORD					isBound(void)
								{	return (m_spJsonRoot.isValid()); }

virtual sp<SurfaceAccessorI>	accessor(Element a_element,String a_name,
										Creation a_create);

virtual sp<SurfaceAccessorI>	accessor(Element a_element,
										Attribute a_attribute,
										Creation a_create);

virtual	BWORD					load(String a_filename);
virtual	BWORD					save(String a_filename);

								//* JSON specific
		void					setJsonRoot(sp<JsonValue> a_spJsonRoot)
								{	m_spJsonRoot=a_spJsonRoot; }

		sp<JsonValue>			jsonRoot(void)		{ return m_spJsonRoot; }

	private:

		sp<JsonValue>			m_spJsonRoot;
};

} // namespace

#endif /* __json_SurfaceAccessibleGeo_h__ */
